/***************************************************************************
 *            params.cc
 *
 *  Wed Jun  8 15:30:56 2005
 *  Copyright  2005  User
 *  Email
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
#include "params.h"
#define BUFSIZE 1000

params::params()
{
	restoredefaults();
}

void params::restoredefaults() 
{
	// DEFAULTS
	// p_d = 0;
	p_r = 12.0;
	
	p_o = 0.75f;
	p_l = -15.0f;
	p_t = -15.0f;
	p_I = 0.028f;
	p_O = 0.03f;
	p_D = 10.0f;
// BOOLS
	p_a = 0;
	p_c = 1;
	p_C = 1;
	p_f = 1;
	p_F = 0;
	p_n = 0;
	p_s = 0;
	p_S = 0;
}

void params::serialize(const string& filename) 
{
	fstream outfile;
  	outfile.open(filename.c_str(), fstream::out);
	if (!outfile.is_open()) return;
  	outfile << p_r << endl;
  	outfile << p_o << endl;
  	outfile << p_l << endl;
  	outfile << p_t << endl;
  	outfile << p_I << endl;
  	outfile << p_O << endl;
  	outfile << p_D << endl;
  	outfile << p_a << endl;
  	outfile << p_c << endl;
  	outfile << p_C << endl;
  	outfile << p_f << endl;
  	outfile << p_F << endl;
  	outfile << p_n << endl;
  	outfile << p_s << endl;
  	outfile << p_S << endl;
  	outfile.close();
}

void params::unserialize(const string& filename) 
{
  	fstream filestr;
  	filestr.open(filename.c_str(), fstream::in);
	if (!filestr.is_open()) return;
  	while(!filestr.eof()) {
		filestr >> p_r;
		filestr >> p_o;
		filestr >> p_l;
		filestr >> p_t;
		filestr >> p_I;
		filestr >> p_O;
		filestr >> p_D;
		filestr >> p_a;
		filestr >> p_c;
		filestr >> p_C;
		filestr >> p_f;
		filestr >> p_F;
		filestr >> p_n;
		filestr >> p_s;
		filestr >> p_S;
  	}
  	filestr.close();
}

void params::buildoptions() 
{
	m_soptionsbuild = " -r "; 
	m_soptionsbuild+= numf(p_r, 2); 
	m_soptionsbuild+= " -o "; 
	m_soptionsbuild+= numf(p_o, 2); 
	m_soptionsbuild+= " -l "; 
	m_soptionsbuild+= numf(p_l, 1); 
	m_soptionsbuild+= " -t "; 
	m_soptionsbuild+= numf(p_t, 1); 
	m_soptionsbuild+= " -I "; 
	m_soptionsbuild+= numf(p_I, 3); 
	m_soptionsbuild+= " -O "; 
	m_soptionsbuild+= numf(p_O, 2); 
	m_soptionsbuild+= " -D "; 
	m_soptionsbuild+= numf(p_D, 1); 
	if (p_a) m_soptionsbuild+= " -a"; 
	if (p_c) m_soptionsbuild+= " -c"; 
	if (p_C) m_soptionsbuild+= " -C"; 
	if (p_f) m_soptionsbuild+= " -f"; 
	if (p_F) m_soptionsbuild+= " -F"; 
	if (p_n) m_soptionsbuild+= " -n"; 
	if (p_s) m_soptionsbuild+= " -s"; 
	if (p_S) m_soptionsbuild+= " -S";
}

int getxcomppid(const string& searchstr)
{
	string strpipe;
	FILE* read_fp;
	char buffer[BUFSIZE+1];
	int chars_read;
	memset(buffer, '\0', sizeof(buffer));
	string search = "ps -A | grep ";
	search += searchstr;
	read_fp = popen(search.c_str(), "r");
	if (read_fp != NULL) {
		chars_read = fread(buffer, sizeof(char), BUFSIZE, read_fp);
		if (chars_read > 0) {
			buffer[chars_read] = 0;
			strpipe += buffer;
		}
	}
	pclose(read_fp);
	int pidnum = 0;
	sscanf(strpipe.c_str(), "%d", &pidnum);
	return pidnum;
}

void createproc(const string& procstr)
{
	string strpipe;
	FILE* read_fp;
	char buffer[BUFSIZE+1];
	int chars_read;
	memset(buffer, '\0', sizeof(buffer));
	read_fp = popen(procstr.c_str(), "r");
	if (read_fp != NULL) {
		chars_read = fread(buffer, sizeof(char), BUFSIZE, read_fp);
		if (chars_read > 0) {
			buffer[chars_read] = 0;
			strpipe += buffer;
		}
	}
	pclose(read_fp);
	// cout << "DEBUG: " << strpipe << endl;
}

void createprocEx(const string& procstr)
{
	FILE* read_fp;
	read_fp = popen(procstr.c_str(), "r");
	pclose(read_fp);
}

const string numf(float n, int precision) 
{
	char buf[20];
	string tmp = "%.";
	tmp += num(precision);
	tmp += "f";
	sprintf(buf, tmp.c_str(), n);
	return strreplace(buf, ",", ".");
}

const string num(int n) 
{
	char buf[10];
	sprintf(buf, "%d", n);
	return buf;
}

string strreplace(string in, string strtorep, string newstr) 
{
	while((signed int)in.find(strtorep) != -1) {
		in.replace (in.find(strtorep),strlen(strtorep.c_str()),newstr);
	}
	return in;
}

void split(const string& delimiter, const string& str, vector<string> &StrArray) 
{ 
   string strtmp = str; 
   while ((signed)strtmp.find(delimiter) != -1) { 
      if (strtmp.substr(0, strtmp.find(delimiter)).size()) { 
         StrArray.push_back(strtmp.substr(0, strtmp.find(delimiter)));  
      } 
      string n = strtmp; 
      strtmp = n.substr(n.find(delimiter) + delimiter.size(), n.size()); 
   } 
   if (strtmp.size()) StrArray.push_back(strtmp);  
} 

bool readinFile(const string& filename, vector<string> &StrArray) 
{ 
  	fstream filestr;
  	filestr.open(filename.c_str(), fstream::in);
	if (!filestr.is_open()) return false;
  	char tmp[BUFSIZE];
  	while(!filestr.eof()) {
  		filestr.getline(tmp, BUFSIZE);
  		StrArray.push_back(tmp);
  	}
  	filestr.close();
	return true;
}

bool writeoutFile(const string& filename, vector<string> &StrArray) 
{
	fstream outfile;
  	outfile.open(filename.c_str(), fstream::out);
	if (!outfile.is_open()) return false;
  	for (unsigned int i = 0; i < StrArray.size(); i++) {
  		outfile << StrArray[i] << endl;
  	}
  	outfile.close();
	return true;
}

bool write_session_file(const string& sessionfilestr, const string& command) 
{
	vector<string> strarr;
	int filepresent = 0, defnum = -1, xstart = 0;
	if (readinFile(sessionfilestr, strarr)) {
		filepresent = 1;
		// grab client number in [Default] section of session-manual
		for (unsigned int i = 0; i < strarr.size(); i++) {
			if (strarr[i].find("[Default]") != string::npos) xstart = 1;
			if (strarr[i].find("xcompmgr") != string::npos && xstart) {
				vector<string> strarr_inner;
				split(",", strarr[i], strarr_inner);
				if (strarr_inner.size() > 1) {
					defnum = atoi(strarr_inner[0].c_str());
				}
			}
		}
	} 
	// cout << defnum << " : " << filepresent << endl;
	//return true;
	
	if (!xstart || !filepresent) {
		// cout << "no previous entries for default" << endl;
		strarr.push_back("[Default]");
		strarr.push_back("num_clients=1");
		strarr.push_back("0,RestartStyleHint=3");
		strarr.push_back("0,Priority=40");
		string tmp = "0,RestartCommand=";
		tmp += command;
		strarr.push_back(tmp);
		if (writeoutFile(sessionfilestr, strarr)) return true; else return false;
	}
	if (defnum == -1) {
		// cout << "no previous entry" << endl;
		int start = 0, updated = 0; 
		string nextnum = "1";
		for (unsigned int i = 0; i < strarr.size(); i++) {
			if (strarr[i].find("[Default]") != string::npos) start = 1;
			if (strarr[i].find("num_clients") != string::npos && start) {
				vector<string> strarr_inner;
				split("=", strarr[i], strarr_inner);
				if (strarr_inner.size() == 2) {
					strarr[i] = "num_clients=";
					strarr[i] += num(atoi(strarr_inner[1].c_str())+1);
					nextnum = num(atoi(strarr_inner[1].c_str()));
				}
			}
			if (checknonzero(strarr[i]) && start) {
				updated = 1;
				string tmp = nextnum;
				tmp += ",RestartCommand=";
				tmp += command;
				vector<string>::iterator p = strarr.begin();
				p += i;
				strarr.insert(p, tmp);
				tmp = nextnum;
				tmp += ",Priority=40";
				strarr.insert(p, tmp);
				tmp = nextnum;
				tmp += ",RestartStyleHint=3";
				strarr.insert(p, tmp);
				break;
			}
		}
		if (!updated) return false;
		if (writeoutFile(sessionfilestr, strarr)) return true; else return false;
	}
	if (defnum != -1) {
		// cout << "previous entry found" << endl;
		int start = 0, updated = 0;
		string tmp_priority = num(defnum);
		tmp_priority += ",";
		string tmp_command = tmp_priority;
		tmp_priority += "Priority=";
		tmp_command += "RestartCommand=";
		for (unsigned int i = 0; i < strarr.size(); i++) {
			if (strarr[i].find("[Default]") != string::npos) start = 1;
			if (strarr[i].find(tmp_priority) != string::npos && start) {
				strarr[i] = num(defnum);
				strarr[i] += ",Priority=40";
			}
			if (strarr[i].find(tmp_command) != string::npos && start) {
				strarr[i] = num(defnum);
				strarr[i] += ",RestartCommand=";
				strarr[i] += command;
				updated = 1;
			}
		}
		if (!updated) return false;
		if (writeoutFile(sessionfilestr, strarr)) return true; else return false;
	}
	return false;
}

string reversestring(const string& instr) {
	string outstr;
	for (int i = instr.size()-1; i >= 0; i--) {
		outstr.push_back(instr[i]);
	}		
	return outstr;
}

bool checknonzero(const string& instr) {
	for (int i = instr.size()-1; i >= 0; i--) {
		if (instr[i] != 32) return false;
	}		
	return true;
}

void savechararray(const string& fname, const unsigned char* pdata, int size) 
{
	FILE* ptr = fopen(fname.c_str(), "r");
	cout << "hello" << endl;
	if (ptr) {
		fclose(ptr);
	} else {
		cout << "hello aga" << endl;
		ptr = fopen(fname.c_str(), "w");
		if (!ptr) return;
		cout << "hello fff" << endl;
		fwrite(pdata, 1, size, ptr);
		fclose(ptr);
	}
}
