/***************************************************************************
 *            stdxinc.cc
 *
 *  Mon Jun 13 00:11:45 2005
 *  Copyright  2005  User
 *  Email
 ****************************************************************************/

#include "stdxinc.h"
#define XC_pirate 88

char *Get_Display_Name(int *pargc, char **argv) 
{
    int argc = *pargc;
    char **pargv = argv+1;
    char *displayname = NULL;
    for (int i = 1; i < argc; i++) {
	char *arg = argv[i];
	if (!strcmp (arg, "-display") || !strcmp (arg, "-d")) {
	    if (++i >= argc) return (char*)-1;
	    displayname = argv[i];
	    *pargc -= 2;
	    continue;
	}
	if (!strcmp(arg,"-")) {
		while (i<argc) *pargv++ = argv[i++];
		break;
	}
	*pargv++ = arg;
    }
    *pargv = NULL;
    return (displayname);
}

void grab_desktop_hwnds(vector<s_wnds> &v_in) 
{
	vector<string> v_exclude;
	// ADD EXCLUDE WINDOWS HERE
	v_exclude.push_back("gnome-panel");	

	if (dpy == NULL) return;
	screen = DefaultScreen(dpy);
	if (screen == -1) return;
	Window wroot, *children, dummy;
	unsigned int nchildren, i;
	wroot=RootWindow((Display*)dpy, screen);
	if (!XQueryTree(dpy, wroot, &dummy, &dummy, &children, &nchildren)) return;
	for (i=0; i < nchildren; i++) {
		XWindowAttributes winatts;
		XGetWindowAttributes(dpy, children[i], &winatts);
		if (winatts.x && winatts.height > 100 && winatts.width > 100) { // make sure it's big enough
			char *window_name;
			XFetchName(dpy, children[i], &window_name);
			if (!window_name) continue;
			string tmpstr = window_name;
			XFree(window_name);
			for (unsigned int j = 0; j < v_exclude.size(); j++) 
				if (v_exclude[j] != tmpstr) { 
					s_wnds stmp;
					stmp.hwnd = (TXWND)children[i];
					stmp.name = tmpstr;
					v_in.push_back(stmp);
    					// if (attr.map_state == IsViewable) //should show if window is flagged as viewable, but whatever
					//printf("window: %d: %s\n", children[i], tmpstr.c_str()); 
				}
		}
	}
	if (children) XFree((char*)children);
}

Window Select_Window(Display *dpy) 
{
  int status;
  Cursor cursor;
  XEvent event;
  Window target_win = None, root = RootWindow(dpy,screen);
  int buttons = 0;

  /* Make the target cursor */
  cursor = XCreateFontCursor(dpy, XC_pirate);

  /* Grab the pointer using target cursor, letting it room all over */
  status = XGrabPointer(dpy, root, False,
			ButtonPressMask|ButtonReleaseMask, GrabModeSync,
			GrabModeAsync, root, cursor, CurrentTime);
  if (status != GrabSuccess) return 0;

  /* Let the user select a window... */
  while ((target_win == None) || (buttons != 0)) {
    /* allow one more event */
    XAllowEvents(dpy, SyncPointer, CurrentTime);
    XWindowEvent(dpy, root, ButtonPressMask|ButtonReleaseMask, &event);
    switch (event.type) {
    case ButtonPress:
      if (target_win == None) {
	target_win = event.xbutton.subwindow; /* window selected */
	if (target_win == None) target_win = root;
      }
      buttons++;
      break;
    case ButtonRelease:
      if (buttons > 0) /* there may have been some down before we started */
	buttons--;
       break;
    }
  } 

  XUngrabPointer(dpy, CurrentTime);      /* Done with pointer */

  return(target_win);
}
